#ifndef _DEBUG_H_
#define _DEBUG_H_

#include <stdio.h>
#include <assert.h>

/* debugging */
#undef DEBUG_SINGLE /* only accept one connection */
/* debugging defines */

#undef DEBUG_KEXHASH

/* don't clear environment variables, useful if we are debugging with
 * something requiring LD_PRELOAD etc, but dangerous if used normally */
#undef DEBUG_KEEP_ENV

/* whether we should try to free() all allocated memory at exit.
 * not required, but useful if running memory checkers like valgrind,
 * to check for leaks */
#undef DOCLEANUP

/* define this to print trace statements */
#define DEBUG_TRACE

#ifdef DEBUG_TRACE
#define TRACE(X) fprintf(stderr, X "\n")
#else /*DEBUG_TRACE*/
#define TRACE(X)
#endif /*DEBUG_TRACE*/

/* for testing as non-root on shadow systems, is mildly incrackable */
#define HACKCRYPT "CsXZUcg07D4R2"

#endif
