#ifndef _DSS_H_
#define _DSS_H_

#include "libtomcrypt/mpi.h"
#include "buffer.h"

#ifdef MSSH_DSS 

#define DSS_SIGNATURE_SIZE 4+SSH_SIGNKEY_DSS_LEN+4+2*SHA1_HASH_SIZE

struct DSS_key {

	mp_int* p;
	mp_int* q;
	mp_int* g;
	mp_int* y;
	mp_int* x;

};

typedef struct DSS_key dss_key;

void buf_put_dss_sign(buffer* buf, dss_key *key, const unsigned char* data,
		unsigned int len);
#ifdef MSSH_SIGNKEY_VERIFY
int buf_dss_verify(buffer* buf, dss_key *key, const unsigned char* data,
		unsigned int len);
#endif
void buf_get_dss_pub_key(buffer* buf, dss_key *key);
void buf_get_dss_priv_key(buffer* buf, dss_key *key);
void buf_put_dss_pub_key(buffer* buf, dss_key *key);
void buf_put_dss_priv_key(buffer* buf, dss_key *key);
void dss_key_free(dss_key *key);

#endif /* MSSH_DSS */

#endif /* _DSS_H_ */
